package br.edu.fei.dcc.raciocinioespacial.editor.shapes;

import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IPathEditorInput;
import org.eclipse.ui.IPersistableElement;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import br.edu.fei.dcc.raciocinioespacial.editor.application.Activator;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.model.ShapesDiagram;

public class ShapesEditorInput implements IPathEditorInput {
	
	private IPath path;
	private String nome;
	private ShapesDiagram diagram;
	
	public ShapesEditorInput(IPath path, String nome) {
		this.path = path;
		this.nome = nome;
	}
	
	public boolean exists() {
		return path.toFile().exists();
	}
	
	public ImageDescriptor getImageDescriptor() {
		return AbstractUIPlugin.imageDescriptorFromPlugin(Activator.PLUGIN_ID, "shapes.gif");
	}
	
	public String getName() {
		return path.toString();
	}
	
	public IPersistableElement getPersistable() {
		return null;
	}
	
	public String getToolTipText() {
		return path.toString();
	}
	
	public Object getAdapter(Class adapter) {
		return null;
	}
	
	@Override
	public int hashCode() {
		return path.hashCode();
	}
	
	public ShapesDiagram getShapesDiagram() {
		if(this.diagram==null)
			this.setShapesDiagram(new ShapesDiagram(this.nome));
		return this.diagram;
	}
	
	public void setShapesDiagram(ShapesDiagram diagram)
	{
		this.diagram = diagram;
	}
	
	public IPath getPath() {
		return path;
	}

	public void setPath(IPath path) {
		this.path = path;
	}	
}