package br.edu.fei.dcc.raciocinioespacial.editor.shapes.actions;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Event;
import org.eclipse.ui.actions.RetargetAction;

import br.edu.fei.dcc.raciocinioespacial.editor.application.Application;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements.Mobile2DShape;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements.Ponto2DShape;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements.Shape;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.model.ShapesDiagram;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.model.command.ShapeCreateCommand;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.parts.ShapeTreeEditPart;

public class CreateNewPointAction extends RetargetAction{

	public static final String ID = "CreateNewPoint";
	public static final String TEXT = "Add Point";
	private ShapesDiagram diagram;
	private EditPartViewer viewer;
	
	public CreateNewPointAction(ShapesDiagram diagram, EditPartViewer viewer)
	{
		super(CreateNewPointAction.ID, CreateNewPointAction.TEXT);
		this.setEnabled(true);
		this.diagram = diagram;
		this.viewer = viewer;
	}


	public ImageDescriptor getDisabledImageDescriptor() {
		return ImageDescriptor.createFromFile(Application.class, "icons/add.gif");
	}

	public ImageDescriptor getHoverImageDescriptor() {
		return ImageDescriptor.createFromFile(Application.class, "icons/add.gif");
	}

	public String getId() {
		return CreateNewPointAction.ID;
	}

	public ImageDescriptor getImageDescriptor() {
		return ImageDescriptor.createFromFile(Application.class, "icons/add.gif");
	}

	public String getText() {
		return CreateNewPointAction.TEXT;
	}

	public String getToolTipText() {
		return "Add point of motion";
	}

	private CreateRequest criarRequisicaoNovoPonto()
	{
		Ponto2DShape novoPonto = new Ponto2DShape();
		CreateRequest retorno = new CreateRequest();
		Point pLoc = this.getActualObjeto2DParent().getLocalization();
		retorno.setLocation(new Point(pLoc.x, pLoc.y+25));
		retorno.setSize(novoPonto.getSize());
		// TODO Mudar para chavear entre pedestre e veiculo
		retorno.setFactory(new NewPointCreationFactory(this.getActualObjeto2DParent()));
		return retorno;
	}
	
	private Shape getActualParent()
	{
		return ((Shape)((ShapeTreeEditPart)((StructuredSelection)this.viewer.getSelection()).toArray()[0]).getModel());
	}
	
	private Mobile2DShape getActualObjeto2DParent()
	{
		if(this.getActualParent() instanceof Mobile2DShape)
			return (Mobile2DShape)this.getActualParent();
		return null;
	}
	
	public void runWithEvent(Event event) {
		if(this.getActualObjeto2DParent() == null) return;
		//Caso haja mais de uma seleo,  considerado apenas o primeiro selecionado.
		ShapeCreateCommand cmd = new ShapeCreateCommand(diagram, this.criarRequisicaoNovoPonto());
		cmd.execute();
	}
}
