package br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements;
import java.util.List;
import java.util.Vector;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;

/**
 * The shape for a pedestrian.
 */
public class Pedestrian2DShape extends Mobile2DShape{

	private static final long serialVersionUID = 1;
	private List<Ponto2DShape> points;
	
	/** Returns the image icon used to represent a pedestrian */
	public Image getIcon() {
		return super.createImage("icons/pedestrian.png");
	}

	@Override
	/** Initiate the object with default configuration */
	protected void inicia() {
		super.inicia();
		this.points = new Vector<Ponto2DShape>();
		this.name = "Ped";
		this.setSize(new Dimension(5, 5));
	}

	/** Returns the name typed by user for the object */
	public String toString() {
		return this.getName();
	}

	/** Returns the route points defined by user for the shape */
	public List<Ponto2DShape> getPoints() {
		return points;
	}

	/** Set the route points defined by user for the shape */
	public void setPoints(List<Ponto2DShape> points) {
		this.points = points;
	}
}