package br.edu.fei.dcc.raciocinioespacial.editor.shapes.elements;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.swt.graphics.Image;

import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.NumericProperty;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.NumericPropertyTypeEnum;
import br.edu.fei.dcc.raciocinioespacial.editor.shapes.properties.TextProperty;


public class Ponto2DShape extends Shape {

	private static final String Property_NomePai = "shapes.pai";
	private static final String Property_Instant = "shapes.instante";
	private static final long serialVersionUID = 1;
	private static int iCount = 1;
	private Mobile2DShape pai;
	
	@Override
	protected void criaPropriedades() {
		this.getDescriptors().add(new TextProperty(Property_NomePai, "Parent Entity"));
		this.getDescriptors().add(new NumericProperty(Property_Instant, "Instant", NumericPropertyTypeEnum.Integer));
		super.criaPropriedades();
	}
	
	public Image getIcon() {
		return super.createImage("icons/ponto.png");
	}

	@Override
	public Object getPropertyValue(Object propertyId) {
		if (Property_NomePai.equals(propertyId)) {
			return this.getNomePai();
		}
		if (Property_Instant.equals(propertyId)) {
			return Integer.toString(this.getInstant());
		}
		return super.getPropertyValue(propertyId);
	}

	@Override
	protected void inicia() {
		super.inicia();
		super.name = "pt"+iCount;
		iCount++;
		super.setSize(new Dimension(3,3));
	}

	@Override
	public void setPropertyValue(Object propertyId, Object value) {
		if (Property_NomePai.equals(propertyId)) {
			this.setNomePai((String)value);
		}
		super.setPropertyValue(propertyId, value);
	}

	public String toString() {
		return this.getName();
	}

	public String getNomePai() {
		return this.pai.getName();
	}

	public void setNomePai(String nomePai) {
		this.pai.setNome(nomePai);
	}

	@Override
	public void setSize(Dimension newSize) {
		return; // It's not possible change the element size!
	}

	@Override
	public void setNome(String name) {
		return; // It's not possible change the name!
	}

	public int getInstant() {
		return this.pai.getPoints().indexOf(this);
	}

	public void setParent(Mobile2DShape parent) {
		this.pai = parent;
	}

	public Mobile2DShape getPai() {
		return pai;
	}
}
