package br.edu.fei.dcc.raciocinioespacial.simulador.execucao;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import br.edu.fei.dcc.raciocinioespacial.simulador.simulacao.Simulacao;

public class DlgDetails extends JDialog {
	private static final long serialVersionUID = 1L;
	private Simulacao simulacao;
	private Dimension tamanhoTela;
	private JPanel espaco;
	private JLabel lblColision;
	private JLabel lblOverTake;
	private JLabel lblBrake;
	private JLabel lblTime;
	private JLabel lblStatus;
	private ImageIcon imgColisionOn;
	private ImageIcon imgColisionOff;
	private ImageIcon imgOverTakeOn;
	private ImageIcon imgOverTakeOff;
	private ImageIcon imgBrakeOn;
	private ImageIcon imgBrakeOff;

	/**
	 * This is the xxx default constructor
	 */
	public DlgDetails(JFrame Owner, Simulacao sim, Dimension tamanhoTela) {
		super(Owner, "Inferences and Details", ModalityType.MODELESS);
		this.tamanhoTela = tamanhoTela;
		this.simulacao = sim;
		this.init();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setSize(this.getTamanhoTela());
		this.setContentPane(this.getEspaco());
		this.simulacao.setLblTime(lblTime);
	}

	public Dimension getTamanhoTela() {
		return tamanhoTela;
	}

	public void setTamanhoTela(Dimension tamanhoTela) {
		this.tamanhoTela = tamanhoTela;
	}

	public JPanel getEspaco() {
		if (this.espaco == null) {
			this.espaco = new JPanel();
			this.espaco.setLayout(null);
			this.espaco.add(getLblColision());
			this.espaco.add(getLblOvertake());
			this.espaco.add(getLblBrake());
			this.espaco.add(getLblTime());
			this.espaco.add(getLblStatus());
		}
		return this.espaco;
	}
	
	public JLabel getLblTime()
	{
		if (this.lblTime == null) {
			this.lblTime = new JLabel();
			this.lblTime.setBounds(5, 45, 180, 21);
			this.lblTime.setText("Duration (ms): 0000");
		}
		return this.lblTime;
	}
	
	public JLabel getLblStatus()
	{
		if (this.lblStatus == null) {
			this.lblStatus = new JLabel();
			this.lblStatus.setBounds(200, 45, 180, 21);
			this.lblStatus.setText("Profiles assimilated: 83");
		}
		return this.lblStatus;
	}
	
	public JLabel getLblColision()
	{
		if (this.lblColision == null) {
			this.lblColision = new JLabel();
			this.lblColision.setBounds(0, 0, 151, 42);
			this.lblColision.setIcon(getImgColisionOFF());
		}
		return this.lblColision;
	}
	
	public JLabel getLblOvertake()
	{
		if (this.lblOverTake == null) {
			this.lblOverTake = new JLabel();
			this.lblOverTake.setBounds(151, 0, 151, 42);
			this.lblOverTake.setIcon(getImgOvertakeOFF());
		}
		return this.lblOverTake;
	}
	
	public JLabel getLblBrake()
	{
		if (this.lblBrake == null) {
			this.lblBrake = new JLabel();
			this.lblBrake.setBounds(302, 0, 151, 42);
			this.lblBrake.setIcon(getImgColisionOFF());
		}
		return this.lblBrake;
	}
	
	public ImageIcon getImgColisionON()
	{
		if (this.imgColisionOn == null) {
			this.imgColisionOn = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Colision_ON")));
		}
		return this.imgColisionOn;
	}
	
	public ImageIcon getImgOvertakeON()
	{
		if (this.imgOverTakeOn == null) {
			this.imgOverTakeOn = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Overtake_ON")));
		}
		return this.imgOverTakeOn;
	}
	
	public ImageIcon getImgBrakeON()
	{
		if (this.imgBrakeOn == null) {
			this.imgBrakeOn = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Brake_ON")));
		}
		return this.imgBrakeOn;
	}
	
	public ImageIcon getImgColisionOFF()
	{
		if (this.imgColisionOff == null) {
			this.imgColisionOff = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Colision_OFF")));
		}
		return this.imgColisionOff;
	}
	
	public ImageIcon getImgOvertakeOFF()
	{
		if (this.imgOverTakeOff == null) {
			this.imgOverTakeOff = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Overtake_OFF")));
		}
		return this.imgOverTakeOff;
	}
	
	public ImageIcon getImgBrakeOFF()
	{
		if (this.imgBrakeOff == null) {
			this.imgBrakeOff = new ImageIcon(this.getClass().getResource(Messages.getString("Simulador.Image_Brake_OFF")));
		}
		return this.imgBrakeOff;
	}

	public void setEspaco(JPanel conteudo) {
		this.espaco = conteudo;
	}
}
