package br.edu.fei.dcc.raciocinioespacial.simulador.movimentacao.colisao;

import java.util.ArrayList;

import br.edu.fei.dcc.raciocinioespacial.simulador.entidades.IEntidade2D;


public class AaBb implements IBroadPhase {
	
	private ArrayList<ColisaoPotencial> objetosComparados;
	
	public AaBb()
	{
		this.objetosComparados = new ArrayList<ColisaoPotencial>();
	}
	
	@Override
	public IEntidade2D[][] executarBroadPhase(IEntidade2D[][] entidades) {
		if(entidades!=null)
		{
			ArrayList<ColisaoPotencial> colisoes = new ArrayList<ColisaoPotencial>();
			for(int i=0; i<entidades.length; i++)
			{
				if(entidades[i].length<=1) continue;
				for(int j=0; j<entidades[i].length; j++)
				{
					ColisaoPotencial cp = new ColisaoPotencial(entidades[i][j],entidades[i]);
					for(IEntidade2D e : cp.getCandidatas())
					{
						if(this.comparar(cp.getEntidade(), e))
						{
							colisoes.add(new ColisaoPotencial(cp.getEntidade(), e));
						}
					}
					this.objetosComparados.add(cp);
				}
			}
			return ColisaoPotencial.listaColisaoPotencialToIEntidade2DArray(colisoes);
		}
		return null;
	}

	private boolean comparar(IEntidade2D a, IEntidade2D b)
	{
		if(!this.comparacaoRealizada(a, b))
		{
			if(a.getRect().intersects(b.getRect()))
				return true;
		}
		return false;
	}
	
	private boolean comparacaoRealizada(IEntidade2D a, IEntidade2D b)
	{
		if(this.objetosComparados!=null)
		{
			for(ColisaoPotencial cp : this.objetosComparados)
			{
				for(IEntidade2D e : cp.getCandidatas())
				{
					if(((e==a)&&(cp.getEntidade()==b))||((e==b)&&(cp.getEntidade()==a)))
						return true;
				}
			}
		}
		return false;
	}
}
