package br.edu.fei.dcc.raciocinioespacial.simulador.movimentacao.colisao;

import java.awt.Rectangle;
import java.util.ArrayList;

import br.edu.fei.dcc.raciocinioespacial.simulador.entidades.IEntidade2D;

public class Particao {
	private ArrayList<IEntidade2D> entidades;
	private Rectangle rect;
	
	public Particao(int x, int y, int w, int h, ArrayList<IEntidade2D> entidades)
	{
		this(new Rectangle(x,y,w,h), entidades);
	}
	
	public Particao(double x, double y, double w, double h, ArrayList<IEntidade2D> entidades)
	{
		this((int)x,(int)y,(int)w,(int)h, entidades);
	}
	
	public Particao(Rectangle rect, ArrayList<IEntidade2D> entidades)
	{
		this.rect = rect;
		this.setEntidades(entidades);
	}

	public ArrayList<IEntidade2D> getEntidades() {
		return entidades;
	}

	public Rectangle getRect() {
		return rect;
	}

	public void setEntidades(ArrayList<IEntidade2D> entidades) {
		this.entidades = new ArrayList<IEntidade2D>();
		for(IEntidade2D e : entidades)
		{
			if(this.getRect().intersects(e.getRect()))
				this.entidades.add(e);
		}
	}

	public void setRect(Rectangle rect) {
		this.rect = rect;
	}
	
	public static ArrayList<Particao> particionar(ArrayList<Particao> particoes, int nroMaximoParticoes, int minEntidadesParticao, int totalObjetos)
	{		
		if((particoes!=null)&&(particoes.size()<nroMaximoParticoes))
		{
			for(Particao p : particoes)
			{
				if((p.getEntidades().size()>minEntidadesParticao)&&
						(p.getEntidades().size()>=(totalObjetos/particoes.size())))
				{
					if((nroMaximoParticoes-particoes.size())>=1)	//Ainda existe vaga?
					{
						Particao a, b;
						if(p.getRect().getHeight()>p.getRect().getWidth())
						{
							a = new Particao(p.getRect().getX(), p.getRect().getY(), p.getRect().getWidth(), p.getRect().getHeight()/2, p.entidades);
							b = new Particao(p.getRect().getX(), p.getRect().getY()+p.getRect().getHeight()/2, p.getRect().getWidth(), p.getRect().getHeight()/2, p.entidades);
						}else
						{
							a = new Particao(p.getRect().getX(), p.getRect().getY(), p.getRect().getWidth()/2, p.getRect().getHeight(), p.entidades);
							b = new Particao(p.getRect().getX()+p.getRect().getWidth()/2, p.getRect().getY(), p.getRect().getWidth()/2, p.getRect().getHeight(), p.entidades);							
						}
						particoes.remove(p);
						particoes.add(a);particoes.add(b);
						return particionar(particoes, nroMaximoParticoes, minEntidadesParticao, totalObjetos);
					}
				}
			}
		}
		return particoes;
	}
	
	public static IEntidade2D[][] listaParticaoToIEntidade2DArray(ArrayList<Particao> particoes)
	{
		IEntidade2D[][] retorno = null;
		if(particoes!=null)
		{
			retorno = new IEntidade2D[particoes.size()][];
			for(int i=0; i<particoes.size(); i++)
			{
				retorno[i] = new IEntidade2D[particoes.get(i).getEntidades().size()];
				particoes.get(i).getEntidades().toArray(retorno[i]);
			}
		}
		return retorno;
	}
}
