package br.edu.fei.dcc.raciocinioespacial.simulador.persistencia;

import java.io.File;
import java.io.FileWriter;
import java.io.OutputStreamWriter;

import br.edu.fei.dcc.raciocinioespacial.simulador.execucao.Simulador;

public class SaidaPerfilProfundidade {
	
	private StringBuilder sbProfiles;
	private String sNameFile;
	private String sExtension;

	public SaidaPerfilProfundidade(StringBuilder allProfiles, String nameFile, String extension) {
		sbProfiles = allProfiles;
		sNameFile  = "DP-"+nameFile;
		sExtension = extension;
	}

    public boolean salvarPerfilProfundidade()
	{
		try
		{
			this.salvar();
			return true;
		}catch(Exception e)
		{
			return false;
		}
	}
	
	private void salvar() throws Exception {
		OutputStreamWriter out = null;
		String nomeArquivo = String.format("%s\\PrologFile\\%s.%s", Simulador.REAL_PATH, sNameFile, sExtension);
		try
		{
			File f = new File(nomeArquivo);
			if(f.exists())
				f.delete();
			out = new FileWriter(nomeArquivo);
			out.write(sbProfiles.toString());
			out.flush();
		}finally
		{
			if(out!=null)
				out.close();
		}
	}
}
